using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Storage;

namespace Zong
{
    class Ball
    {

        //i used private members for x and y because I wanted to test the whole get/set thing
        private int mX;
        public int X
        {
            get
            {
                return mX;
            }
            set
            {
                mX = value;
            }
        }
        private int mY;
        public int Y
        {
            get
            {
                return mY;
            }
            set
            {
                mY = value;
            }
        }

        public int Width;
        public int Height;

        public int VX;
        public int VY;

        public bool Visible;

        Texture2D mTexture;

        //constructor
        public Ball(GraphicsDevice theGraphicsDevice, ContentManager theContentManager,int BallWidth, int BallHeight)
        {
            X = 300;
            Y = 300;

            VX = -5;
            VY = 5;

            Width=BallWidth;
            Height=BallHeight;

            Visible = true;

            mTexture = theContentManager.Load<Texture2D>("./images/ball_60x60") as Texture2D;
        }

        //Draw the ball
        public void Draw(SpriteBatch theSpriteBatch)
        {
            if (Visible)
            {
                theSpriteBatch.Draw(mTexture, new Rectangle(mX,mY,Width,Height), Color.White);
            }
        }

        //update the ball movement
        public void Update(GameWindow Screen)
        {
            mX+=VX;
            mY+=VY;

            //top and bottom screen collisions
            if(mY<0)
            {
                mY = 0;
                VY *= -1;
            }
            else if (mY + Height > Screen.ClientBounds.Height)
            {
                mY = Screen.ClientBounds.Height-Height;
                VY *= -1;
            }

            //side screen collisions (scoring condition)
            //ball will just bounce for now for demo purposes
            if (mX <= 0)
            {
                mX = (Screen.ClientBounds.Width / 2 )-(Width/2);
                mY = (Screen.ClientBounds.Height / 2) - (Height / 2);
                VX = Math.Abs(VX);
            }
            else if (mX + Width >= Screen.ClientBounds.Width)
            {
                mX = (Screen.ClientBounds.Width / 2) - (Width / 2);
                mY = (Screen.ClientBounds.Height / 2) - (Height / 2);
                VX = -1*Math.Abs(VX);
            }

        }
           
    }
}
